unit uGenChk;

interface

function ACCapPawn(destpos:integer; pcurrmove:pointer):pointer;
function ACCapBishop(posmem:integer; pcurrmove:pointer):pointer;
function ACCapRook(posmem:integer; pcurrmove:pointer):pointer;
function CCapKnight(destpos,piece:integer; pcurrmove:pointer):pointer;
function BCCapPawn(destpos:integer; pcurrmove:pointer):pointer;
function BCCapBishop(posmem:integer; pcurrmove:pointer):pointer;
function BCCapRook(posmem:integer; pcurrmove:pointer):pointer;


implementation


uses uMisc;

function ACCapBishop(posmem:integer; pcurrmove:pointer):pointer;
asm
  push esi
  mov esi, eax
  push edi
  mov ecx, [edx];
  mov edi, edx
  push ebx
  add ecx, MCAPTURE
  xor ebx, ebx

  lea edx, [esi+17]
  mov eax, ecx
@dne:
  mov bl, byte ptr [edx]
  add edx, 17
  add eax, 17 shl 7
  test bl, bl
  jz @dne
  cmp bl, AQUEEN
  setz dl
  cmp bl, ABISHOP;
  setz bl
  add bl,dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  lea edx, [esi+15]
  mov eax, ecx
@dnw:
  mov bl, byte ptr [edx]
  add edx, 15
  add eax, 15 shl 7
  test bl, bl
  jz @dnw
  cmp bl, AQUEEN
  setz dl
  cmp bl, ABISHOP;
  setz bl
  add bl,dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  lea edx, [esi-15]
  mov eax, ecx
@dse:
  mov bl, byte ptr [edx]
  sub edx, 15
  sub eax, 15 shl 7
  test bl, bl
  jz @dse
  cmp bl, AQUEEN
  setz dl
  cmp bl, ABISHOP;
  setz bl
  add bl,dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  lea edx, [esi-17]
  mov eax, ecx
@dsw:
  mov bl, byte ptr [edx]
  sub edx, 17
  sub eax, 17 shl 7
  test bl, bl
  jz @dsw
  cmp bl, AQUEEN
  setz dl
  cmp bl, ABISHOP;
  setz bl
  add bl,dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  pop ebx
  mov eax, edi
  pop edi
  pop esi
end;

function ACCapRook(posmem:integer; pcurrmove:pointer):pointer;
asm
  push esi
  mov esi, eax
  push edi
  mov ecx, [edx];
  mov edi, edx
  push ebx
  add ecx, MCAPTURE
  xor ebx, ebx

  lea edx, [esi+16]
  mov eax, ecx
@dn:
  mov bl, byte ptr [edx]
  add edx, 16
  add eax, 16 shl 7
  test bl, bl
  jz @dn
  cmp bl, AQUEEN
  setz dl
  cmp bl, AROOK;
  setz bl
  add bl, dl
  mov [edi], eax
  mov edx, ebp
  lea edi, [edi + ebx*4]

  lea edx, [esi-16]
  mov eax, ecx
@ds:
  mov bl, byte ptr [edx]
  sub edx, 16
  sub eax, 16 shl 7
  test bl, bl
  jz @ds
  cmp bl, AQUEEN
  setz dl
  cmp bl, AROOK;
  setz bl
  add bl, dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  lea edx, [esi+1]
  mov eax, ecx
@de:
  mov bl, byte ptr [edx]
  inc edx
  add eax, 1 shl 7
  test bl, bl
  jz @de
  cmp bl, AQUEEN
  setz dl
  cmp bl, AROOK;
  setz bl
  add bl, dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  lea edx, [esi-1]
  mov eax, ecx
@dw:
  mov bl, byte ptr [edx]
  dec edx
  sub eax, 1 shl 7
  test bl, bl
  jz @dw
  cmp bl, AQUEEN
  setz dl
  cmp bl, AROOK;
  setz bl
  add bl, dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  pop ebx
  mov eax, edi
  pop edi
  pop esi
end;

function ACCapPawn(destpos:integer; pcurrmove:pointer): pointer;
asm
  push esi
  mov esi, eax
  push ebx
  mov eax, [edx]
  add eax, MCAPTURE
  xor ebx, ebx

  mov ecx, eax
  cmp byte ptr [esi-15], APAWN
  setz bl
  sub ecx, 15 shl 7
  mov dword ptr [edx], ecx
  lea edx, [edx + ebx*4]

  mov ecx, eax
  cmp byte ptr [esi-17], APAWN
  setz bl
  sub ecx, 17 shl 7
  mov dword ptr [edx], ecx
  lea edx, [edx + ebx*4]

  pop ebx
  mov eax, edx
  pop esi
end;

function CCapKnight(destpos,piece:integer; pcurrmove:pointer):pointer;
asm
  push esi
  mov esi, eax
  push edi
  mov edi, ecx
  push ebx
  mov eax, [ecx]
  add eax, MCAPTURE
  xor ebx, ebx

  mov ecx, eax
  cmp byte ptr [esi+14], dl
  setz bl
  add ecx, 14 shl 7
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  cmp byte ptr [esi-14], dl
  setz bl
  sub ecx, 14 shl 7
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  cmp byte ptr [esi+18], dl
  setz bl
  add ecx, 18 shl 7
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  cmp byte ptr [esi-18], dl
  setz bl
  sub ecx, 18 shl 7
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  cmp byte ptr [esi+31], dl
  setz bl
  add ecx, 31 shl 7
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  cmp byte ptr [esi-31], dl
  setz bl
  sub ecx, 31 shl 7
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  cmp byte ptr [esi+33], dl
  setz bl
  add ecx, 33 shl 7
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  cmp byte ptr [esi-33], dl
  setz bl
  sub ecx, 33 shl 7
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  pop ebx
  mov eax, edi
  pop edi
  pop esi
end;

function BCCapPawn(destpos:integer; pcurrmove:pointer):pointer;
asm
  push esi
  mov esi, eax
  push ebx
  mov eax, [edx]
  add eax, MCAPTURE
  xor ebx, ebx

  mov ecx, eax
  cmp byte ptr [esi+15], BPAWN
  setz bl
  add ecx, 15 shl 7
  mov dword ptr [edx], ecx
  lea edx, [edx + ebx*4]

  mov ecx, eax
  cmp byte ptr [esi+17], BPAWN
  setz bl
  add ecx, 17 shl 7
  mov dword ptr [edx], ecx
  lea edx, [edx + ebx*4]

  pop ebx
  mov eax, edx
  pop esi
end;

function BCCapBishop(posmem:integer; pcurrmove:pointer):pointer;
asm
  push esi
  mov esi, eax
  push edi
  mov ecx, [edx];
  mov edi, edx
  push ebx
  add ecx, MCAPTURE
  xor ebx, ebx

  lea edx, [esi+17]
  mov eax, ecx
@dne:
  mov bl, byte ptr [edx]
  add edx, 17
  add eax, 17 shl 7
  test bl, bl
  jz @dne
  cmp bl, BQUEEN
  setz dl
  cmp bl, BBISHOP;
  setz bl
  add bl,dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  lea edx, [esi+15]
  mov eax, ecx
@dnw:
  mov bl, byte ptr [edx]
  add edx, 15
  add eax, 15 shl 7
  test bl, bl
  jz @dnw
  cmp bl, BQUEEN
  setz dl
  cmp bl, BBISHOP;
  setz bl
  add bl,dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  lea edx, [esi-15]
  mov eax, ecx
@dse:
  mov bl, byte ptr [edx]
  sub edx, 15
  sub eax, 15 shl 7
  test bl, bl
  jz @dse
  cmp bl, BQUEEN
  setz dl
  cmp bl, BBISHOP;
  setz bl
  add bl,dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  lea edx, [esi-17]
  mov eax, ecx
@dsw:
  mov bl, byte ptr [edx]
  sub edx, 17
  sub eax, 17 shl 7
  test bl, bl
  jz @dsw
  cmp bl, BQUEEN
  setz dl
  cmp bl, BBISHOP;
  setz bl
  add bl,dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  pop ebx
  mov eax, edi
  pop edi
  pop esi
end;

function BCCapRook(posmem:integer; pcurrmove:pointer):pointer;
asm
  push esi
  mov esi, eax
  push edi
  mov ecx, [edx];
  mov edi, edx
  push ebx
  add ecx, MCAPTURE
  xor ebx, ebx

  lea edx, [esi+16]
  mov eax, ecx
@dn:
  mov bl, byte ptr [edx]
  add edx, 16
  add eax, 16 shl 7
  test bl, bl
  jz @dn
  cmp bl, BQUEEN
  setz dl
  cmp bl, BROOK;
  setz bl
  add bl, dl
  mov [edi], eax
  mov edx, ebp
  lea edi, [edi + ebx*4]

  lea edx, [esi-16]
  mov eax, ecx
@ds:
  mov bl, byte ptr [edx]
  sub edx, 16
  sub eax, 16 shl 7
  test bl, bl
  jz @ds
  cmp bl, BQUEEN
  setz dl
  cmp bl, BROOK;
  setz bl
  add bl, dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  lea edx, [esi+1]
  mov eax, ecx
@de:
  mov bl, byte ptr [edx]
  inc edx
  add eax, 1 shl 7
  test bl, bl
  jz @de
  cmp bl, BQUEEN
  setz dl
  cmp bl, BROOK;
  setz bl
  add bl, dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  lea edx, [esi-1]
  mov eax, ecx
@dw:
  mov bl, byte ptr [edx]
  dec edx
  sub eax, 1 shl 7
  test bl, bl
  jz @dw
  cmp bl, BQUEEN
  setz dl
  cmp bl, BROOK;
  setz bl
  add bl, dl
  mov [edi], eax
  xor edx, edx
  lea edi, [edi + ebx*4]

  pop ebx
  mov eax, edi
  pop edi
  pop esi
end;


end.
